//
//  Huffman Code 1.0
//  Decode.cpp
//
//  Created by Amittai Aviram on 2 Sep 2018.
//  Copyright © 2018 Amittai Aviram. All rights reserved.
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

#include "HuffmanDecoder.hpp"
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <string>

void usage(char ** argv)
{
    std::cerr << "Usage:\n";
    std::cerr << argv[0] << " <input_file>\n";
    std::cerr << argv[0] << " <input_file> <output_file>\n";
}

int main(int argc, char ** argv)
{
    if (argc < 2)
    {
        usage(argv);
        exit(EXIT_FAILURE);
    }

    std::cout << "Huffman Decoder" << std::endl;
    const std::string input_file(argv[1]);
    std::cout << "Decoding from " << input_file << " ..." << std::endl;
    HuffmanDecoder decoder;
    if (argc < 3)
    {
        decoder.readMessageFromFileAndDecode(input_file);
        std::cout << "Decoded text:\n" << std::endl;
        std::cout << decoder.decodedMessage() << std::endl;
    }
    else
    {
        const std::string output_file(argv[2]);
        decoder.readMessageFromFileAndDecode(input_file, output_file);
    }
    return EXIT_SUCCESS;
}
